defmodule AoC2021.Test25 do
  use ExUnit.Case, async: true

  alias AoC2021.Day25

  @data %{
    {0, 0} => ?v, {4, 0} => ?>, {5, 0} => ?>, {7, 0} => ?v, {8, 0} => ?v, {9, 0} => ?>,
    {1, 1} => ?v, {2, 1} => ?v, {3, 1} => ?>, {4, 1} => ?>, {6, 1} => ?v, {7, 1} => ?v,
    {0, 2} => ?>, {1, 2} => ?>, {3, 2} => ?>, {4, 2} => ?v, {5, 2} => ?>, {9, 2} => ?v,
    {0, 3} => ?>, {1, 3} => ?>, {2, 3} => ?v, {3, 3} => ?>, {4, 3} => ?>, {6, 3} => ?>, {8, 3} => ?v,
    {0, 4} => ?v, {1, 4} => ?>, {2, 4} => ?v, {4, 4} => ?v, {5, 4} => ?v, {7, 4} => ?v,
    {0, 5} => ?>, {2, 5} => ?>, {3, 5} => ?>, {6, 5} => ?v,
    {1, 6} => ?v, {2, 6} => ?v, {5, 6} => ?>, {7, 6} => ?>, {8, 6} => ?v,
    {0, 7} => ?v, {2, 7} => ?v, {5, 7} => ?>, {6, 7} => ?>, {7, 7} => ?v, {9, 7} => ?v,
    {4, 8} => ?v, {7, 8} => ?v, {9, 8} => ?>
  }

  test "setup" do
    assert Day25.setup("#{__DIR__}/data/test.txt") === @data
  end

  test "part1" do
    assert Day25.part1(@data) === 58
  end

  test "part2" do
    assert Day25.part2(@data) === IO.ANSI.format([:yellow, String.duplicate("*", 50)])
  end
end
